﻿; ================================
; = Platformer Tileset Generator =
; =        By Retro-Bruno        =
; = (c) Freeware 2015/2016       =
; =  Made with Purebasic         =
; ================================
;

Declare.i Operate(n$)

UsePNGImageDecoder()
UsePNGImageEncoder()

If Not OpenConsole("Platformer Tileset Generator")
  MessageRequester("Error", "Can't open console !", 0)
  End
EndIf

PrintN("Platformer Tileset Generator")
PrintN("By Retro-Bruno")
PrintN("")
PrintN("Create a New Directory in the same Directory as this program.")
PrintN("Then, paste four tiles in it called :")
PrintN("'front.png', 'v-edges.png', 'h-edges.png' and 'back.png'")
PrintN("")
PrintN("The Front/Edges will be mixed together.")
PrintN("Take a look at the Example Directory...")
PrintN("")
PrintN("Now, enter the Width of a Tile, in pixels.")
PrintN("Must be a pair number :")
Global w = Val(Input())
While w <= 0 Or w > 800
  PrintN("Bad Tile size... Try again :")
  w = Val(Input())
Wend

Global x = 0
Global y = 0
Global h = w
Global mw = w * 10
Global mh = h * 10
  
PrintN("")
PrintN("Now, enter the name of your Directory :")
name$ = Input()
While FileSize(GetCurrentDirectory() + name$) <> -2
  PrintN("Bad Directory name... Try again :")
  name$ = Input()
Wend
PrintN("")

CreateImage(0, w * 10, w * 10, 32, #PB_Image_Transparent)
If Operate(name$) <> #False
  PrintN("Tileset done !")
  wait$ = Input()
Else
  PrintN("Error, Tileset not done.")
  wait$ = Input()
EndIf

FreeImage(tileset)
CloseConsole()
End

; ================================

Procedure GrabTriangleUpLeft(i1, i2, xt, yt, wt, ht)
  CreateImage(i2, w, h, 32, #PB_Image_Transparent)
  While wt > 0 And yt < ht
    GrabImage(i1, 9, xt, yt, wt, 1)
    StartDrawing(ImageOutput(i2))
    DrawingMode(#PB_2DDrawing_AllChannels)
    DrawImage(ImageID(9), xt, yt)
    StopDrawing()
    FreeImage(9)
    xt + 1
    yt + 1
    wt - 1
  Wend
EndProcedure

Procedure GrabTriangleDownLeft(i1, i2, xt, yt, wt, ht)
  CreateImage(i2, w, h, 32, #PB_Image_Transparent)
  While wt > 0 And yt > ht
    GrabImage(i1, 9, xt, yt, wt, 1)
    StartDrawing(ImageOutput(i2))
    DrawingMode(#PB_2DDrawing_AllChannels)
    DrawImage(ImageID(9), xt, yt)
    StopDrawing()
    FreeImage(9)
    xt + 1
    yt - 1
    wt - 1
  Wend
EndProcedure

Procedure GrabTriangleUpRight(i1, i2, xt, yt, wt, ht)
  CreateImage(i2, w, h, 32, #PB_Image_Transparent)
  While wt > 0 And yt < ht
    GrabImage(i1, 9, xt, yt, wt, 1)
    StartDrawing(ImageOutput(i2))
    DrawingMode(#PB_2DDrawing_AllChannels)
    DrawImage(ImageID(9), xt, yt)
    StopDrawing()
    FreeImage(9)
    yt + 1
    wt - 1
  Wend
EndProcedure

Procedure GrabTriangleDownRight(i1, i2, xt, yt, wt, ht)
  CreateImage(i2, w, h, 32, #PB_Image_Transparent)
  While wt > 0 And yt > ht
    GrabImage(i1, 9, xt, yt, wt, 1)
    StartDrawing(ImageOutput(i2))
    DrawingMode(#PB_2DDrawing_AllChannels)
    DrawImage(ImageID(9), xt, yt)
    StopDrawing()
    FreeImage(9)
    yt - 1
    wt - 1
  Wend
EndProcedure

Procedure WhiteUp(im)
  StartDrawing(ImageOutput(im))
  DrawingMode(#PB_2DDrawing_AllChannels)
  Box(0, 0, w, h / 2, RGBA(255, 255, 255, 255))
  StopDrawing()
EndProcedure

Procedure WhiteDown(im)
  StartDrawing(ImageOutput(im))
  DrawingMode(#PB_2DDrawing_AllChannels)
  Box(0, h / 2, w, h / 2, RGBA(255, 255, 255, 255))
  StopDrawing()
EndProcedure

Procedure WhiteRight(im)
  StartDrawing(ImageOutput(im))
  DrawingMode(#PB_2DDrawing_AllChannels)
  Box(w / 2, 0, w / 2, h, RGBA(255, 255, 255, 255))
  StopDrawing()
EndProcedure

Procedure WhiteLeft(im)
  StartDrawing(ImageOutput(im))
  DrawingMode(#PB_2DDrawing_AllChannels)
  Box(0, 0, w / 2, h, RGBA(255, 255, 255, 255))
  StopDrawing()
EndProcedure

Procedure CreateUp()
  
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(7), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  
  CopyImage(7, 9)
  GrabImage(5, 10, 0, 0, w, h)
  WhiteDown(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)

  CopyImage(7, 9)
  GrabImage(6, 10, 0, 0, w, h)
  WhiteDown(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)
  
  CopyImage(7, 9)
  GrabImage(5, 10, 0, 0, w, h)
  WhiteDown(10)
  WhiteRight(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)

  CopyImage(7, 9)
  GrabImage(5, 10, 0, 0, w, h)
  WhiteDown(10)
  WhiteLeft(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)
  
  CopyImage(7, 9)
  GrabImage(6, 10, 0, 0, w, h)
  WhiteDown(10)
  WhiteRight(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)

  CopyImage(7, 9)
  GrabImage(6, 10, 0, 0, w, h)
  WhiteDown(10)
  WhiteLeft(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)
  
EndProcedure

Procedure CreateDown()
  
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(7), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  
  CopyImage(7, 9)
  GrabImage(5, 10, 0, 0, w, h)
  WhiteUp(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)

  CopyImage(7, 9)
  GrabImage(6, 10, 0, 0, w, h)
  WhiteUp(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)
  
  CopyImage(7, 9)
  GrabImage(5, 10, 0, 0, w, h)
  WhiteUp(10)
  WhiteRight(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)

  CopyImage(7, 9)
  GrabImage(5, 10, 0, 0, w, h)
  WhiteUp(10)
  WhiteLeft(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)
  
  CopyImage(7, 9)
  GrabImage(6, 10, 0, 0, w, h)
  WhiteUp(10)
  WhiteRight(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)

  CopyImage(7, 9)
  GrabImage(6, 10, 0, 0, w, h)
  WhiteUp(10)
  WhiteLeft(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)
  
EndProcedure

Procedure CreateUpAndDown()
  
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(7), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  
  CopyImage(7, 9)
  GrabImage(5, 10, 0, 0, w, h)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)

  CopyImage(7, 9)
  GrabImage(6, 10, 0, 0, w, h)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)
  
  CopyImage(7, 9)
  GrabImage(5, 10, 0, 0, w, h)
  WhiteRight(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)

  CopyImage(7, 9)
  GrabImage(5, 10, 0, 0, w, h)
  WhiteLeft(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)
  
  CopyImage(7, 9)
  GrabImage(6, 10, 0, 0, w, h)
  WhiteRight(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)

  CopyImage(7, 9)
  GrabImage(6, 10, 0, 0, w, h)
  WhiteLeft(10)
  StartDrawing(ImageOutput(10))
  DrawingMode(#PB_2DDrawing_Default)
  DrawImage(ImageID(9), 0, 0)
  StopDrawing()
  FreeImage(9)
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(10), x, y)
  StopDrawing()
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  FreeImage(10)
  
EndProcedure

Procedure.i Operate(n$)

  
  If Not LoadImage(5, "filter1.png") Or Not LoadImage(6, "filter2.png")
    ProcedureReturn #False
  EndIf
  ResizeImage(5, w, h, #PB_Image_Raw)
  ResizeImage(6, w, h, #PB_Image_Raw)
  
  SetCurrentDirectory(n$)
  If Not LoadImage(1, "front.png") Or Not LoadImage(2, "back.png") Or Not LoadImage(3, "v-edges.png") Or Not LoadImage(4, "h-edges.png")
    ProcedureReturn #False
  EndIf
  
  ; Insert Back and Front images
  StartDrawing(ImageOutput(0))
  DrawingMode(#PB_2DDrawing_AllChannels)
  DrawImage(ImageID(2), x, y)
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  
  DrawImage(ImageID(1), x, y)
  x + w
  If x = mw
    x = 0
    y + h
  EndIf
  StopDrawing()
  
  ; Create Combos : Front + Top of V-Edge
  CopyImage(1, 7)
  GrabImage(3, 8, 0, 0, w, h / 2)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, 0)
  StopDrawing()
  
  FreeImage(8) 
  CreateUp()
  FreeImage(7) 
  
  ; Create Combos : Front + Bottom of V-Edge
  CopyImage(1, 7)
  GrabImage(3, 8, 0, h / 2, w, h / 2)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, h / 2)
  StopDrawing()
  
  FreeImage(8) 
  CreateDown()
  FreeImage(7) 
  
  ; Create Combos : Front + Full V-Edge
  CopyImage(1, 7)
  GrabImage(3, 8, 0, 0, w, h)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, 0)
  StopDrawing()
   
  FreeImage(8)
  CreateUp()
  CreateDown()
  CreateUpAndDown()
  FreeImage(7) 
  
  ; Create Combos : Front + Full V-Edge + Full H-Edge
  CopyImage(1, 7)
  GrabImage(4, 8, 0, 0, w / 2, h)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, 0)
  StopDrawing()
  
  FreeImage(8)
  
  GrabImage(4, 8, w / 2, 0, w / 2, h)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), w / 2, 0)
  StopDrawing()
  
  FreeImage(8)
  
  GrabImage(3, 8, 0, 0, w, h / 2)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, 0)
  StopDrawing()
  
  FreeImage(8)
  
  GrabImage(3, 8, 0, h / 2, w, h / 2)

  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, h / 2)
  StopDrawing()
  
  FreeImage(8)
  CreateUp()
  CreateDown()
  CreateUpAndDown()
  FreeImage(7)
  
    ; Create Combos : Front + Full V-Edge + Left H-Edge
  CopyImage(1, 7)
  GrabImage(4, 8, 0, 0, w / 2, h)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, 0)
  StopDrawing()
  
  FreeImage(8)

  GrabTriangleUpLeft(3, 8, 0, 0, w, h / 2)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, 0)
  StopDrawing()
  
  FreeImage(8)
  
  GrabTriangleDownLeft(3, 8, 0, h - 1, w, h / 2)

  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, 0)
  StopDrawing()
  
  FreeImage(8)
  CreateUp()
  CreateDown()
  CreateUpAndDown()
  FreeImage(7)
  
  ; Create Combos : Front + Full V-Edge + Right H-Edge
  CopyImage(1, 7)
  GrabImage(4, 8, w / 2, 0, w / 2, h)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), w / 2, 0)
  StopDrawing()
  
  FreeImage(8)
  
  GrabTriangleUpRight(3, 8, 0, 0, w, h / 2)
  
  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, 0)
  StopDrawing()
  
  FreeImage(8)
  
  GrabTriangleDownRight(3, 8, 0, h - 1, w, h / 2)

  StartDrawing(ImageOutput(7))  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  DrawImage(ImageID(8), 0, 0)
  StopDrawing()
  
  FreeImage(8)
  CreateUp()
  CreateDown()
  CreateUpAndDown()
  FreeImage(7)
  
  If Not SaveImage(0, "tileset.png", #PB_ImagePlugin_PNG)
    ProcedureReturn #False
  EndIf
  
  ProcedureReturn #True

EndProcedure
; IDE Options = PureBasic 5.41 LTS (Windows - x64)
; CursorPosition = 648
; FirstLine = 638
; Folding = ---
; EnableUnicode
; EnableXP
; Executable = PTG.exe